PR(1)

NAME
pr - print files

SYNOPSIS
pr [+page] [- column] [-adFfmrt] [-e[char][gap]] [-h header] [-i[char][gap]] [-l lines] [-n[char][width]] [-o offset] [-s[char]] [-w width] [file ...]

DESCRIPTION
The pr utility is a printing and pagination filter for text files. When multiple input files are specified, each is read, formatted, and written to standard output. By default, the input is separated into 66-line pages, each with

•   A 5-line header with the page number, date, time, and the pathname of the file.

•   A 5-line trailer consisting of blank lines.

Optionally, the trailer can be replaced by a <form-feed> where this is more appropriate for the output device being used and <tab>s can be expanded to input relative <spaces>s or <space>s can be contracted to output relative <tab>s. The pr utility also interprets <form-feed>s in the input as the logical end of pages.

When multiple column output is specified, text columns are of equal width. By default text columns are separated by at least one <blank>. Input lines that do not fit into a text column are truncated, except in the default single columns output mode.

Error messages are written to standard error during the printing process (if output is redirected) or after all successful file printing is complete (when printing to a terminal). If pr receives an interrupt while printing to a terminal, it flushes all accumulated error messages to the screen before terminating.

The options are as follows:

+page
    Begin output at page number page of the formatted input.

- column
    Produce output that is columns wide (default is 1) that is written vertically down each column in the order in which the text is received from the input file. The options -e and -i are assumed. This option should not be used with -m. When used with -t, the minimum number of lines is used to display the output.

-a  Modify the effect of the - column option so that the columns are filled across the page in a round-robin order (e.g., when column is 2, the first input line heads column 1, the second heads column 2, the third is the second line in column 1, etc.). This option requires the use of the - column option.

-d  Produce output that is double spaced. An extra <newline> character is output following every <newline> found in the input.

-e[char][gap]
    Expand each input <tab> to the next greater column position specified by the formula n*gap+1, where n is an integer > 0. If gap is zero or is omitted the default is 8. All <tab> characters in the input are expanded into the appropriate number of <space>s. If any nondigit character, char, is specified, it is used as the input tab character.

-F  Use a <form-feed> character for new pages, instead of the default behavior that uses a sequence of <newline> characters.

-f  Same as the -F option.

-h header
    Use the string header to replace the file name in the header line.

-i[char][gap]
    In output, replace multiple <space>s with <tab>s whenever two or more adjacent <space>s reach column positions gap+1, 2*gap+1, etc. If gap is zero or omitted, default <tab> settings at every eighth column position is used. If any nondigit character, char, is specified, it is used as the output <tab> character.

-l lines
    Override the 66 line default and reset the page length to lines. If lines is not greater than the sum of both the header and trailer depths (in lines), the pr utility suppresses output of both the header and trailer, as if the -t option were in effect.

-m  Merge the contents of multiple files. One line from each file specified by a file operand is written side by side into text columns of equal fixed widths, in terms of the number of column positions. The number of text columns depends on the number of file operands successfully opened. The maximum number of files merged depends on page width and the per process open file limit. The options -e and -i are assumed.

-n[char][width]
    Provide width digit line numbering. The default for width, if not specified, is 5. The number occupies the first width column positions of each text column or each line of -m output. If char (any nondigit character) is given, it is appended to the line number to separate it from whatever follows. The default for char is a <tab>. Line numbers longer than width columns are truncated.

-o offset
    Each line of output is preceded by offset <spaces>s. If the -o option is not specified, the default is zero. The space taken is in addition to the output line width.

-r  Write no diagnostic reports on failure to open a file.

-s[char]
    Separate text columns by the single character char instead of by the appropriate number of <space>s (default for char is the <tab> character).

-t  Print neither the five-line identifying header nor the five-line trailer usually supplied for each page. Quit printing after the last line of each file without spacing to the end of the page.

-w width
    Set the width of the line to width column positions for multiple text-column output only. If the -w option is not specified and the -s option is not specified, the default width is 72. If the -w option is not specified and the -s option is specified, the default width is 512.

file
    A pathname of a file to be printed. If no file operands are specified, or if a file operand is ‘-’, the standard input is used. The standard input is used only if no file operands are specified, or if a file operand is ‘-’.

EXIT STATUS

SEE ALSO
cat(1), more(1), ascii(7)

STANDARDS
The pr utility is compliant with the p1003.1-2008 specification.

The flag [-f] is marked by p1003.1-2008 as being an X/Open System Interfaces option.

p1003.1-2008 is relatively silent concerning the handling of input characters beyond the behavior dictated by the pr required command options.

HISTORY
A pr command appeared in AT&T UNIX.

CAVEATS
The interpretation of <form-feed>s in the input stream is that they are special <newline>s which have the side effect of causing a page break. While this works correctly for all cases, strict interpretation also implies that the common convention of placing a <form-feed> on a line by itself is actually interpreted as a blank line, page break, blank line.

The pr utility is intended to paginate input containing basic ascii(7) text formatting and input streams containing non-printing <control-characters>, <escape-sequences> or long lines may result in formatting errors.

The pr utility does not currently understand over-printing using <back-space> or <return> characters, and except in the case of unmodified single-column output, use of these characters will cause formatting errors.

BUGS
The lack of a line wrapping option, and the specification that truncation does not apply to single-column output frequently results in formatting errors when input lines are longer than actual line width of the output device.

The default width of 72 is archaic and non-obvious since it is normally ignored in the default single column mode. Using the -m option with one column provides a way to truncate single column output but there's no way to wrap long lines to a fixed line width.

The default of <tab> for the separator for the -n and -s options often results in lines apparently wider than expected.